
############################
############################ VECTOR
############################

# vectors
a<-c(2)
a
b<-c(4)
b

### simple math

a*b
b/a
b^a
b+a
b-a

# factorial
factorial(b)

# vectors with n>1
x<-c(-1,2,4,7)
x
length(x)

x/2

# display the elements of a vector

x[2]    # display the 2nd element
x[1:2]  # display the first 2 elements
x[x>0]  # display all the elements > 0
x[x<0]  # display all the elements < 0
x[x<4]  # display all the elements < 4

x<-c(1.2,3,4,5,6,8,9,10)
# display all the elements >= 2 and < 8 
x[x>=2&x<8]

# mathematical operations with a vector

sum(x1)     # sum
prod(x1)    # product
length(x1)  # length
range(x1)   # min, max and range
min(x1)
max(x1)

################### matrixes and operations between matrices

### arrays can be both numeric and categorical
### we will only deal with the numbers.

### the functions to obtain a matrix are: 1) matrix; 2) cbind; 3) rbind

A1<-matrix(c(1,0.2,0.4,0.5), ncol=2) 
class(A1)

## display the element (1,2):
A1[1,2]

## the first row
A1[1,]

## the second column
A1[,2]

## The sum of the first row:
sum(A1[1,])

row_1<-c(1,2,3)
row_2<-c(3,4,1)
row_3<-c(1,0.2,1)

A3_1<-matrix(c(row_1,row_2,row_3),ncol=3,byrow=T) 

## rbind and cbind

A3_2<-rbind(row_1,row_2,row_3)

A3_3<-cbind(row_1,row_2,row_3)

dim(A3_3)

### functions diag, t, apply e colMeans

diag(A3_1)

t(A3_1)

colMeans(A3_1)

apply(A3_1,2,median)	

apply(A3_1,1,min)

################### Matrix

## det 

a1<-matrix(c(2,1,4,3),ncol=2)

det(a1)

## inverse of a matrix (if det is different from 0)

inv_a1<-solve(a1)